local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local Assert = BaikCore.Assert
local Log = BaikCore.Log
local Option = BaikCore.Option
local OrderNumber = BaikCore.OrderNumber

-- Add Module
local BaikUnitFrame = BaikCore:NewModule("BaikUnitFrame")
BaikCore.BaikUnitFrame = BaikUnitFrame
local orderNumber = OrderNumber:Create()
BaikUnitFrame.OrderNumber = orderNumber

-- Constants
BaikUnitFrame.OPTION_NAME = "unit_frame"

local OPTION = {
    name = "Unit Frame",
    type = "group",
    childGroups = "tab",
    order = Option:GeneralOrderNumber(),
    args = {}
}

-- Member Variables

-- BaikUnitFrame API
function BaikUnitFrame:AddOption(name, opts)
    Assert:String(name)
    Assert:Table(opts)

    Assert:Null(OPTION.args[name])

    OPTION.args[name] = opts
end

function BaikUnitFrame:GetOptionArgs()
    return OPTION.args
end

-- Ace3 Callbacks
function BaikUnitFrame:OnInitialize()
    Log:v("BaikUnitFrame_OnInitialize")
    Option:AddCategory(self.OPTION_NAME, OPTION)
end

function BaikUnitFrame:OnEnable()
    Log:v("BaikUnitFrame_OnEnable")
end

function BaikUnitFrame:OnDisable()
    Log:v("BaikUnitFrame_OnDisable")
end
